---
title: Document.write()
slug: Web/API/Document/write
tags:
  - API
  - DOM
  - Document
  - Method
  - Reference
  - write
---
<div>{{ApiRef("DOM")}}</div>

<p>The <strong><code>Document.write()</code></strong> method writes a string of text to a document stream opened by {{domxref("document.open()")}}.</p>

<div class="note"><strong>Note</strong>: Because <code>document.write()</code> writes to the document <strong>stream</strong>, calling <code>document.write()</code> on a closed (loaded) document automatically calls <code>document.open()</code>, <a href="/en-US/docs/Web/API/document.open#Notes">which will clear the document</a>.</div>

<h2 id="Syntax">Syntax</h2>

<pre class="brush: js notranslate"><var>document</var>.write(<var>markup</var>);
</pre>

<h3 id="Parameters">Parameters</h3>

<dl>
 <dt><var>markup</var></dt>
 <dd>A string containing the text to be written to the document.</dd>
</dl>

<h3 id="Example">Example</h3>

<pre class="brush: html notranslate">&lt;html&gt;

&lt;head&gt;
  &lt;title&gt;Write example&lt;/title&gt;

  &lt;script&gt;
    function newContent() {
      document.open();
      document.write("&lt;h1&gt;Out with the old, in with the new!&lt;/h1&gt;");
      document.close();
    }
  &lt;/script&gt;
&lt;/head&gt;

&lt;body onload="newContent();"&gt;
  &lt;p&gt;Some original document content.&lt;/p&gt;
&lt;/body&gt;

&lt;/html&gt;
</pre>

<p>{{EmbedLiveSample("Syntax")}}</p>

<h2 id="Notes">Notes</h2>

<p>The text you write is parsed into the document's structure model. In the example above, the <code>h1</code> element becomes a node in the document.</p>

<p>Writing to a document that has already loaded without calling {{domxref("document.open()")}} will automatically call <code>document.open()</code>. After writing, call {{domxref("document.close()")}} to tell the browser to finish loading the page.</p>

<p>If the <code>document.write()</code> call is embedded within an inline HTML <code>&lt;script&gt;</code> tag, then it will not call <code>document.open()</code>. For example:</p>

<pre class="brush: html notranslate">&lt;script&gt;
  document.write("&lt;h1&gt;Main title&lt;/h1&gt;")
&lt;/script&gt;
</pre>

<div class="note"><strong>Note</strong>: <code>document.write()</code> and {{domxref("document.writeln")}} <a href="/en-US/docs/Archive/Web/Writing_JavaScript_for_HTML">do not work in XHTML documents</a> (you'll get an "Operation is not supported" [<code>NS_ERROR_DOM_NOT_SUPPORTED_ERR</code>] error in the error console). This happens when opening a local file with the .xhtml file extension or for any document served with an <code>application/xhtml+xml</code> {{Glossary("MIME type")}}. More information is available in the <a class="external" href="http://www.w3.org/MarkUp/2004/xhtml-faq#docwrite">W3C XHTML FAQ</a>.</div>

<div class="note"><strong>Note</strong>: Using <code>document.write()</code> in <a href="/en-US/docs/Web/HTML/Element/script#attr-defer">deferred</a> or <a href="/en-US/docs/Web/HTML/Element/script#attr-async">asynchronous</a> scripts will be ignored and you'll get a message like "A call to <code>document.write()</code> from an asynchronously-loaded external script was ignored" in the error console.</div>

<div class="note"><strong>Note</strong>: In Edge only, calling <code>document.write()</code> more than once in an {{HTMLElement("iframe")}} causes the error "SCRIPT70: Permission denied".</div>

<div class="note"><strong>Note</strong>: Starting with version 55, Chrome will not execute <code>&lt;script&gt;</code> elements injected via <code>document.write()</code> when specific conditions are met. For more information, refer to <a href="https://developers.google.com/web/updates/2016/08/removing-document-write">Intervening against document.write()</a>.</div>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{SpecName("HTML WHATWG", "#dom-document-write", "document.write(...)")}}</td>
   <td>{{Spec2("HTML WHATWG")}}</td>
   <td></td>
  </tr>
  <tr>
   <td>{{SpecName("DOM2 HTML", "html.html#ID-75233634", "document.write(...)")}}</td>
   <td>{{Spec2("DOM2 HTML")}}</td>
   <td></td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<div>{{Compat("api.Document.write")}}</div>

<h2 id="See_also">See also</h2>

<ul>
 <li>{{domxref("element.innerHTML")}}</li>
 <li>{{domxref("document.createElement()")}}</li>
</ul>
